package com.hai.dao;

import com.hai.entity.HighOrderPre;
import com.hai.entity.HighOrderPreExample.Criteria;
import com.hai.entity.HighOrderPreExample.Criterion;
import com.hai.entity.HighOrderPreExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighOrderPreSqlProvider {

    public String countByExample(HighOrderPreExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_order_pre");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighOrderPreExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_order_pre");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighOrderPre record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_order_pre");
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.VALUES("merchant_id", "#{merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantStoreId() != null) {
            sql.VALUES("merchant_store_id", "#{merchantStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getPreOrderNo() != null) {
            sql.VALUES("pre_order_no", "#{preOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderId() != null) {
            sql.VALUES("order_id", "#{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.VALUES("child_order_id", "#{childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.VALUES("pay_real_price", "#{payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsType() != null) {
            sql.VALUES("goods_type", "#{goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.VALUES("goods_id", "#{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.VALUES("goods_name", "#{goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getPreTime() != null) {
            sql.VALUES("pre_time", "#{preTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPreUserId() != null) {
            sql.VALUES("pre_user_id", "#{preUserId,jdbcType=BIGINT}");
        }
        
        if (record.getPreUserName() != null) {
            sql.VALUES("pre_user_name", "#{preUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getPreUserPhone() != null) {
            sql.VALUES("pre_user_phone", "#{preUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getPreUserRemark() != null) {
            sql.VALUES("pre_user_remark", "#{preUserRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getStatusFailDesc() != null) {
            sql.VALUES("status_fail_desc", "#{statusFailDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getStatusCancelDesc() != null) {
            sql.VALUES("status_cancel_desc", "#{statusCancelDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getReachTime() != null) {
            sql.VALUES("reach_time", "#{reachTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getReachAddress() != null) {
            sql.VALUES("reach_address", "#{reachAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserId() != null) {
            sql.VALUES("op_user_id", "#{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.VALUES("op_user_name", "#{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.VALUES("ext_4", "#{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.VALUES("ext_5", "#{ext5,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighOrderPreExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("company_id");
        sql.SELECT("merchant_id");
        sql.SELECT("merchant_store_id");
        sql.SELECT("agent_id");
        sql.SELECT("pre_order_no");
        sql.SELECT("order_id");
        sql.SELECT("order_no");
        sql.SELECT("child_order_id");
        sql.SELECT("pay_real_price");
        sql.SELECT("goods_type");
        sql.SELECT("goods_id");
        sql.SELECT("goods_name");
        sql.SELECT("pre_time");
        sql.SELECT("pre_user_id");
        sql.SELECT("pre_user_name");
        sql.SELECT("pre_user_phone");
        sql.SELECT("pre_user_remark");
        sql.SELECT("`status`");
        sql.SELECT("status_fail_desc");
        sql.SELECT("status_cancel_desc");
        sql.SELECT("reach_time");
        sql.SELECT("reach_address");
        sql.SELECT("op_user_id");
        sql.SELECT("op_user_name");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("ext_4");
        sql.SELECT("ext_5");
        sql.FROM("high_order_pre");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighOrderPre record = (HighOrderPre) parameter.get("record");
        HighOrderPreExample example = (HighOrderPreExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_order_pre");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.SET("merchant_id = #{record.merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantStoreId() != null) {
            sql.SET("merchant_store_id = #{record.merchantStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getPreOrderNo() != null) {
            sql.SET("pre_order_no = #{record.preOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.SET("child_order_id = #{record.childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.SET("pay_real_price = #{record.payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{record.goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.SET("goods_name = #{record.goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getPreTime() != null) {
            sql.SET("pre_time = #{record.preTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPreUserId() != null) {
            sql.SET("pre_user_id = #{record.preUserId,jdbcType=BIGINT}");
        }
        
        if (record.getPreUserName() != null) {
            sql.SET("pre_user_name = #{record.preUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getPreUserPhone() != null) {
            sql.SET("pre_user_phone = #{record.preUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getPreUserRemark() != null) {
            sql.SET("pre_user_remark = #{record.preUserRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getStatusFailDesc() != null) {
            sql.SET("status_fail_desc = #{record.statusFailDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getStatusCancelDesc() != null) {
            sql.SET("status_cancel_desc = #{record.statusCancelDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getReachTime() != null) {
            sql.SET("reach_time = #{record.reachTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getReachAddress() != null) {
            sql.SET("reach_address = #{record.reachAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_order_pre");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("merchant_id = #{record.merchantId,jdbcType=BIGINT}");
        sql.SET("merchant_store_id = #{record.merchantStoreId,jdbcType=BIGINT}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("pre_order_no = #{record.preOrderNo,jdbcType=VARCHAR}");
        sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("child_order_id = #{record.childOrderId,jdbcType=BIGINT}");
        sql.SET("pay_real_price = #{record.payRealPrice,jdbcType=DECIMAL}");
        sql.SET("goods_type = #{record.goodsType,jdbcType=INTEGER}");
        sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        sql.SET("goods_name = #{record.goodsName,jdbcType=VARCHAR}");
        sql.SET("pre_time = #{record.preTime,jdbcType=TIMESTAMP}");
        sql.SET("pre_user_id = #{record.preUserId,jdbcType=BIGINT}");
        sql.SET("pre_user_name = #{record.preUserName,jdbcType=VARCHAR}");
        sql.SET("pre_user_phone = #{record.preUserPhone,jdbcType=VARCHAR}");
        sql.SET("pre_user_remark = #{record.preUserRemark,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("status_fail_desc = #{record.statusFailDesc,jdbcType=VARCHAR}");
        sql.SET("status_cancel_desc = #{record.statusCancelDesc,jdbcType=VARCHAR}");
        sql.SET("reach_time = #{record.reachTime,jdbcType=TIMESTAMP}");
        sql.SET("reach_address = #{record.reachAddress,jdbcType=VARCHAR}");
        sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        
        HighOrderPreExample example = (HighOrderPreExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighOrderPre record) {
        SQL sql = new SQL();
        sql.UPDATE("high_order_pre");
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.SET("merchant_id = #{merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantStoreId() != null) {
            sql.SET("merchant_store_id = #{merchantStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getPreOrderNo() != null) {
            sql.SET("pre_order_no = #{preOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.SET("child_order_id = #{childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.SET("pay_real_price = #{payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.SET("goods_name = #{goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getPreTime() != null) {
            sql.SET("pre_time = #{preTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPreUserId() != null) {
            sql.SET("pre_user_id = #{preUserId,jdbcType=BIGINT}");
        }
        
        if (record.getPreUserName() != null) {
            sql.SET("pre_user_name = #{preUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getPreUserPhone() != null) {
            sql.SET("pre_user_phone = #{preUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getPreUserRemark() != null) {
            sql.SET("pre_user_remark = #{preUserRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getStatusFailDesc() != null) {
            sql.SET("status_fail_desc = #{statusFailDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getStatusCancelDesc() != null) {
            sql.SET("status_cancel_desc = #{statusCancelDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getReachTime() != null) {
            sql.SET("reach_time = #{reachTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getReachAddress() != null) {
            sql.SET("reach_address = #{reachAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{ext5,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighOrderPreExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}